/// 2PSet with support for state and op changes
export class TwoPSet {
    _adds;
    _removes;
    constructor(adds, removes) {
        this._adds = adds;
        this._removes = removes;
    }
    lookup(element) {
        return this._adds.lookup(element) && !this._removes.lookup(element);
    }
    add(element) {
        this._adds.add(element);
    }
    remove(element) {
        this._removes.add(element);
    }
    adds() {
        return this._adds;
    }
    removes() {
        return this._removes;
    }
    compare(peerSet) {
        return (this._adds.compare(peerSet.adds()) &&
            this._removes.compare(peerSet.removes()));
    }
    merge(peerSet) {
        this._adds.merge(peerSet.adds());
        this._removes.merge(peerSet.removes());
    }
}
