/// GCounter with support for state and op changes
export class GCounter {
    globalCounter;
    // instead of standard incremental id for replicas
    // we map the counter with the node id
    counts;
    constructor(counts) {
        this.globalCounter = Object.values(counts).reduce((a, b) => a + b, 0);
        this.counts = counts;
    }
    value() {
        return this.globalCounter;
    }
    increment(nodeId, amount) {
        this.globalCounter += amount;
        this.counts[nodeId] += amount;
    }
    compare(peerCounter) {
        for (let key in Object.keys(this.counts)) {
            if (this.counts[key] > peerCounter.counts[key]) {
                return false;
            }
        }
        return true;
    }
    merge(peerCounter) {
        let temp = Object.assign({}, this.counts, peerCounter.counts);
        Object.keys(temp).forEach((key) => {
            this.counts[key] = Math.max(this.counts[key], peerCounter.counts[key]);
        });
    }
}
